<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="职业健康" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Input style="width: 200px; margin-right: 10px" v-model="searchFields.KeyWord" placeholder="关键字搜索" />
              <Button type="primary" @click="load" style="margin-left: 10px">查询</Button>
              <Button type="primary" @click="edit()" style="margin-left: 10px">新增</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div ref="lxTable">
        <el-table :data="tableData" class="v-table" :height="tableHeight" style="width: 100%">
          <el-table-column type="index" width="50" align="center" fixed="left"> </el-table-column>
          <el-table-column :prop="column.field" :align="column.align" v-for="(column,index) in columns"
            :label="column.title" :width="column.width" :fixed="column.fixed">
            <template slot-scope="scope">
              <div v-if="column.type=='opt'">
                <Button ghost size="small" @click="edit(scope.row)" type="primary"
                  style="margin-left: 10px;">编辑</Button>
                <Button ghost size="small" @click="del(scope.row)" type="error" style="margin-left: 10px;">删除</Button>
              </div>
              <div v-else-if="column.type=='dangerType'">
                <div v-for="item in parameters.dangerType">
                  <div v-if='scope.row[column.field]==item.id'>
                    {{item.value}}
                  </div>
                </div>

              </div>
              <div v-else-if="column.type=='dangerLevel'">
                <div v-for="item in parameters.dangerLevel">
                  <div v-if='scope.row[column.field]==item.id'>
                    {{item.value}}
                  </div>
                </div>

              </div>
              <div v-else-if="column.type=='format'">
                <div v-if="column.field=='admin'">
                  {{scope.row[column.field]?scope.row[column.field].name:""}}
                </div>
                <div v-if="column.field=='department'">
                  {{scope.row[column.field]?scope.row[column.field].name:""}}
                </div>
              </div>
              <div v-else-if="column.type=='unit'">
                <div v-for="item in deptOptions">
                  <div v-if='scope.row[column.field]==item.id'>
                    {{item.name}}
                  </div>
                </div>

              </div>
              <div v-else>{{scope.row[column.field]}}</div>
            </template>
          </el-table-column>
        </el-table>
        <div class="pagination">
          <el-pagination @current-change="handleCurrentChange" :current-page="paginations.page"
            :page-size="paginations.page_size" background layout="prev, pager, next" :total="paginations.total">
          </el-pagination>
        </div>
      </div>

    </div>

    <el-dialog title="职业健康编辑" :visible.sync="dialogFormVisible" fullscreen width="90%">
      <div class="dialogConcent" :style="{height:clientHeight+'px'}">
        <el-scrollbar style="flex: 1">
          <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
            <el-row>
              <el-col :span="8">
                <el-form-item label="科室,运维管理单位" prop="unit" class="units">
                  <el-select v-model="form.unit" placeholder="请选择科室,运维管理单位" style="width: 100%">
                    <el-option v-for="item in deptOptions" :key="item.id" :label="item.name" :value="item.id">
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="8">
                <el-form-item label="职业危害类型" prop="danger_type" class="units">
                  <el-select v-model="form.danger_type" placeholder="请选择职业危害类型" style="width: 100%">
                    <el-option v-for="item in this.parameters.dangerType" :key="item.id" :label="item.value" :value="item.id">
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="8" :offset="8">
                <el-form-item label="联系电话" prop="mobile">
                  <el-input v-model="form.mobile" placeholder="请填写联系电话" autocomplete="off"></el-input>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="8">
                <el-form-item label="职业危害严重程度" prop="danger_level" class="units">
                  <el-select v-model="form.danger_level" placeholder="请选择职业危害严重程度" style="width: 100%">
                    <el-option v-for="item in this.parameters.dangerLevel" :key="item.id" :label="item.value" :value="item.id">
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="8" :offset="8">
                <el-form-item label="辨识日期" prop="date" label-position="right">
                  <el-date-picker style="width:100%" type="date" v-model="form.date" value-format="yyyy-MM-dd HH:mm:ss"
                   placeholder="辨识日期">
                  </el-date-picker>
                </el-form-item>
              </el-col>
            </el-row>
            <el-form-item class="" label="可能造成的危害" prop="danger">
              <el-input type="textarea" :rows="3" v-model="form.danger" placeholder="请填写可能造成的危害" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item class="" label="预防措施" prop="measure">
              <el-input type="textarea" :rows="3" v-model="form.measure" placeholder="请填写预防措施" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="参与辨识单位" prop="distinguish_units_list">
              <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange">全选
              </el-checkbox>
              <div style="margin: 15px 0;"></div>
              <el-checkbox-group v-model="form.distinguish_units_list" @change="handleCheckedDeptChange">
                <el-checkbox v-for="dept in deptOptions" :label="dept.id" :key="dept.id">{{dept.name}}</el-checkbox>
              </el-checkbox-group>
            </el-form-item>

              <el-form-item label="参与辨识人员" prop="distinguish_people_list">
                <el-transfer filterable :titles="['待选择', '已选择']" :props="{key: 'id',label: 'name'}"
                  :filter-method="filterMethod" :format="{ noChecked: '${total}',hasChecked: '${checked}/${total}' }"
                  filter-placeholder="请选择参与辨识人员" v-model="form.distinguish_people_list" :data="userdata">
                </el-transfer>
              </el-form-item>

            <el-form-item class="" label="备注" prop="remark">
              <el-input type="textarea" :rows="3" v-model="form.remark" placeholder="请填写备注" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="附件" prop="files_list">
              <el-upload class="upload-demo" :on-success="handlesuccess" :data="uploadOther"
                :action="action" :on-remove="handleRemove" :before-remove="beforeRemove"
                :on-exceed="handleExceed" :file-list="fileList">
                <el-button size="small" type="primary">点击上传</el-button>
              </el-upload>
            </el-form-item>

          </el-form>
        </el-scrollbar>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" v-preventReClick @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>


  </div>
</template>

<script>
  import {
    getToken
  } from '@/utils/auth'
  import LxHeader from "@/components/LxHeader/index.vue";
  import Tinymce from '@/components/Tinymce'
  import {
    save,
    store,
    del,
    get,
    listtask
  } from "../../api/site/health.js";
  import {
    getparameteritem
  } from "../../api/system/dictionary.js";
  import {
    listdept
  } from "../../api/system/department.js";
  import {
    listCommonuser
  } from "../../api/common.js"
  export default {
    components: {
      LxHeader,
      Tinymce
    },
    data() {
      return {      action:`${process.env.VUE_APP_BASE_API}api/admin/upload-file`,
        checkAll: false,
        isIndeterminate: true,
        infoFormVisible:false,
        parameters: {
          dangerType: [],
          dangerLevel:[]
        },
        paginations: {
          page: 1,
          page_size: 15,
          total: 0
        },
        tableHeight: 0,
        dialogFormVisible: false,
        formLabelWidth: "120px",
        clientHeight: 0,
        form: {
          unit: "",
          danger_type: "",
          mobile: "",
          danger_level: "",
          date: "",
          danger: "",
          measure:"",
          remark:"",
          files_list:"",
          distinguish_people_list:[],
          distinguish_units_list:[],
        },
        //查询条件字段
        searchFields: {
          KeyWord: ""
        },
        fileList:[],
        details_list: [],
        tableData: [],
        rules: {
          unit: [{
            required: true,
            message: '请选择科室，运维管理单位',
            trigger: 'blur'
          }],
          danger_type: [{
            type:'number',
            required: true,
            message: '请选择职业危害类型',
            trigger: 'blur'
          }],
          mobile: [{
            required: true,
            message: '请填写联系电话',
            trigger: 'blur',
          },{
            pattern:/^1[3456789]\d{9}$/,
            message: '请输入正确的联系电话',
            trigger: 'blur',
          }],
          danger_level: [{
            type:'number',
            message: '请选择职业危害严重程度',
            trigger: 'blur'
          }],
          date: [{
            message: '请选择辨识日期',
            trigger: 'blur'
          }],
          danger: [{
            message: '请填写可能造成的危害',
            trigger: 'blur'
          }],
          measure: [{
            message: '请填写预防措施',
            trigger: 'blur'
          }],
          // distinguish_units_list: [{
          //   message: '请选择参与辨识单位',
          //   trigger: 'blur'
          // }],
          // distinguish_people_list: [{
          //   message: '请选择参与辨识人员',
          //   trigger: 'blur'
          // }],
          remark: [{
            message: '请填写备注',
            trigger: 'blur'
          }],
        },
        columns: [{
            field: "date",
            title: "辨识日期",
            type: "string",
            width: 120,
            align:"left"
          },{
            field: "danger_type",
            title: "职业危害类型",
            type: "dangerType",
            align:"center",
            width:120
          },
          {
            field: "danger_level",
            title: "职业危害严重程度",
            type: "dangerLevel",
            width: 120,
            align:"center"
          },
          {
            field: "unit",
            title: "科室",
            width: 180,
            type: "unit",
            align:"center"
          },
          {
            field: "mobile",
            title: "联系电话",
            type: "string",
            width: 120,
            align:"center"
          },
          {
            field: "created_at",
            title: "创建时间",
            type: "string",
            width: 180,
            align: "center"
          },
          {
            field: "admin",
            title: "创建人",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "department",
            title: "创建人科室",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "操作",
            title: "操作",
            width: 220,
            type: "opt",
            fixed:"right"
          }
        ],
        uploadOther: {
          token: ""
        },
        deptOptions: [],
        userdata: [],
        filterMethod(query, item) {
          return item.name.indexOf(query) > -1;
        },
      }
    },
    created() {
      this.uploadOther.token = getToken();
      this.loadDeptOptions();
      this.loadUser();
      this.initLoad();
      this.load();

    },
    methods: {
      loadDeptOptions() {
        listdept().
        then((res) => {
          this.deptOptions = res;
        }).catch(error => {
          console.log(error)
          reject(error)
        })
      },
      loadUser() {
        listCommonuser({
          page_size: 999
        }).
        then((res) => {
          this.userdata = res.data;
        }).catch(error => {
          console.log(error)
        })
      },
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;
        //加载自定义参数
        getparameteritem("dangerLevel").then(res => {
          this.parameters.dangerLevel = res.detail;
        });
        //加载自定义参数
        getparameteritem("dangerType").then(res => {
          this.parameters.dangerType = res.detail;
        });
      },
      handleCurrentChange(page) {
        this.paginations.page = page;
        this.load();
      },
      load() {
        listtask({
          page: this.paginations.page,
          page_size: this.paginations.page_size,
          keyword:this.searchFields.KeyWord
        }).then(response => {
          this.tableData = response.data;
          this.paginations.total = response.total;
        }).catch(error => {
          console.log(error)
          reject(error)
        })

      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
      info(obj) {
        var that = this;

        get(obj.id).then(res => {
          let result = Object.assign(that.form, res);
          that.form = result;
          let _files = [];
          for (var mod of result.health_files) {
            let m = Object.assign({}, mod["files"]);
            m.name = mod["files"].original_name;
            _files.push(m);
          }
          that.fileList = _files;
          for (var m of result.distinguish_people) {
            if (m.admins)
              that.form.distinguish_people_list.push(m.admins.id)
          }
          for (var m of result.distinguish_units) {
            if (m.department_id)
              that.form.distinguish_units_list.push(m.department_id)
          }

        }).catch(error => {
          //reject(error)
        })
      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogFormVisible = true;
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            var arr = [];
            for (var m of this.form.distinguish_people_list) {
              arr.push({
                admin_id: m
              })
            }
            this.form.distinguish_people_list = arr;
            var arrs = [];
            for (var m of this.form.distinguish_units_list) {
              arrs.push({
                department_id: m
              })
            }
            this.form.distinguish_units_list = arrs;
            if (that.form.id) {
              that.form.id = that.form.id;
              save(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;
              }).catch(error => {
                //reject(error)
              })
            } else {
              store(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;
              }).catch(error => {
                //reject(error)
              })
            }
          } else {
            this.$Message.error('数据校验失败');
            console.log('error submit!!');
            return false;
          }
        });
      },
      resetForm(formName) {
        var that = this;
        this.fileList=[];
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
      },
      handleCheckAllChange(val) {
        console.log(val)
        let options = [];
        for (var m of this.deptOptions) {
          options.push(m.id);
        }
        this.form.distinguish_units_list = val ? options : [];
        this.isIndeterminate = false;
      },
      handleCheckedDeptChange(value) {
        let checkedCount = value.length;
        this.checkAll = checkedCount === this.deptOptions.length;
        this.isIndeterminate = checkedCount > 0 && checkedCount < this.deptOptions.length;
      },
      handleRemove(file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});
        }
        this.form.files_list = listUrl;
      },
      handleExceed(files, fileList) {},
      beforeRemove(file, fileList) {
        return this.$confirm(`确定移除 ${ file.name }？`);
      },
      handlesuccess(response, file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});

        }
        this.form.files_list = listUrl;
      },
    }
  }
</script>

<style>
  .dialogConcent {
    overflow-y: auto;
  }
  .units label{
    line-height: 22px;
  }

</style>
